#ifndef CONTEXT_HH
#define CONTEXT_HH

#include <vector>
using std::vector;

struct Context {
  Context( bool b_ = false, bool em_ = false, bool i_ = false,
	   bool s_ = false, bool tt_ = false, int u_ = 0, int size_ = -1,
	   char color_ = '?' );

  bool b;
  bool em;
  bool i;
  bool s;
  bool tt;
  int u;
  int size;
  char color;

  bool operator==( const Context& cxt ) const;
  bool operator!=( const Context& cxt ) const;
  Context GetSpaceContext();
};

typedef vector<Context> Context_vec;
typedef Context_vec::iterator Context_vec_i;
    
#endif // CONTEXT_HH not defined.
