#include "parser.hh"

Parser::Parser()
{
}

void Parser::BuildTree( SMLTag& doc )
{
  char c;
  string strTag="";
  string strText="";
 
  c = cin.get(); 
  while( cin && !cin.eof() )
  {
    if( c == '<' )
    {
      GetTag(strTag);
      if( strTag[0] != '/' )
      {
	if( strText != "" )
	{
	  SMLText* text = new SMLText(strText);
	  doc.subs.push_back(text); 
	  strText = "";
	}
	
	SMLTagType eTagType = GetTagType(strTag); 
	SMLTag* tag = new SMLTag( eTagType );
	tag->cxt = doc.cxt;
	BuildTree(*tag);
	doc.subs.push_back(tag);
      }
      else
      {
	break;
      }
    }
    else
    {
      strText += c;
    }
    c = cin.get();
  }
  
  if( strText != "" )
  {
    SMLText* text = new SMLText(strText);
    doc.subs.push_back(text); 
    strText = "";
  }

  doc.CalculateContexts();
}

bool Parser::GetTag( string& strTag )
{
  strTag = "";
  
  char c = cin.get();
  while( c != '>' ) {
    strTag += c;
    c = cin.get();
  }

  return true;
}
