#ifndef UTIL_HH
#define UTIL_HH

#include "sml.hh"

bool IsAllWhiteSpace( const string& s );
bool ContainsText( SMLTag* tag );

bool IsColourUsed( SMLTag* tag, char c );
bool IsSizeUsed( SMLTag* tag, int size );

bool IsAllInAttr( SMLTag* tag, SMLTagType type );
bool IsAllInColour( SMLTag* tag, char c );
bool IsAllInSize( SMLTag* tag, int size );

bool IsPlainContext( Context& cxt );
Context GetContextAtDepth( SMLTag* tag, int depth );
SMLTag* GetTagAtDepth( SMLTag* tag, int depth );
int GetTagDepth( SMLTag* tag );
bool IsHiddenByPL( SMLTagType t );

#endif // UTIL_HH not defined
