#include "context.hh"

Context::Context( bool b_, bool em_, bool i_, bool s_, bool tt_, int u_,
    int size_, char color_ )
: b(b_), em(em_), i(i_), s(s_), tt(tt_), u(u_), size(size_), color(color_)
{
}

bool
Context::operator==( const Context& cxt ) const
{
  return b == cxt.b &&
         em == cxt.em &&
         i == cxt.i &&
         s == cxt.s &&
         tt == cxt.tt &&
         u == cxt.u &&
         size == cxt.size &&
         color == cxt.color;
}

bool
Context::operator!=( const Context& cxt ) const
{
  return !operator==(cxt);
}

Context
Context::GetSpaceContext()
{
  Context cxt;

  cxt.tt = tt;
  cxt.u = u;
  cxt.size = size;
  cxt.color = (u == 0 ? 'w' : color);

  return cxt;
}
