#ifndef OPTIMIZER_HH
#define OPTIMIZER_HH

#include "sml.hh"

struct Optimizer {
  virtual ~Optimizer() { }
  string name;

  virtual void Optimize( SMLTag& doc ) = 0;
};

typedef list<Optimizer*> Optimizer_list;
typedef list<Optimizer*>::iterator Optimizer_list_i;

#endif // OPTIMIZER_HH not defined.
